var progressBar;
var currentProgressStep = 0;
var totalProgressStep = 5;
var progressStepValues = [];

var eventGroupListJsonPath = "./media/milestoneAndEventsList.json";
var eventGroupListJSON;
var eventGroupListArray;
var currentEventGroup = 0;
var currentEventInEventGroup = 0;
var currentEventPageName = ".stage-eventChoice-1";

var startingSavings = 0.00;
var startingKiwisaver = 0.00;
var startingWellbeing = 0.00;

var currentSavings;
var currentKiwisaver;
var currentWellbeing;
var maxWellbeingLevel = 9600;

var currentChangeSavings = 0;
var currentChangeKiwisaver = 0;
var currentChangeWellbeing = 0;

const maxConsecutiveChoicesForWarning = 2;
var warningChoiceSavingsCount = 0;
var warningChoiceKiwisaverCount = 0;
var warningChoiceWellbeingCount = 0;

var warningChoiceSavingsCountChange = 0;
var warningChoiceKiwisaverCountChange = 0;
var warningChoiceWellbeingCountChange = 0;

var totalSavings = 0;
const superPerWeek = 436.94;

var salaryStarting = 0;
var salaryCurrent = 0;
var salarySavingPercent = 0;
var kiwisaverContributionPercent = 0;
const perAnnumSalaryIncreasePercent = 0.026;

var budget = 0;
var totalSpend = 0;
var currentChangeTotalSpend = 0;

var currentSelectedEventChoice = null;
var trackedChoices = [];

var eventChoiceChangesAllowed = 1;
var eventChoiceChangesUsed = 0;

var categoriesListJsonPath = "./media/categoryList.json";
var categoriesListJSON;
var categoriesListArray;

var previousCategoriesIndexes = [];
var selectedCategoriesIndexes = [];
var currentSelectedCategory = null;

const currencyFormatter = new Intl.NumberFormat('en-US', {
        style: 'currency',
        currency: 'USD',
    });;


/* Init
–––––––––––––––––––––––––––––––––––––––––––––––––– */
$(document).ready(function () {

    progressBar = $('#progressBar');

    loadEventGroupJSON(eventGroupListJsonPath);
    loadBudgetCategoriesJSON(categoriesListJsonPath);

    reset();

    //Setup buttons for all stages
    setupMilestoneButtonEvents();
    setupEventChoiceButtonEvents();
    setupEventResultButtonEvents();
    setupBudgetCalculationButtonEvents();
    setupCategorySelectionButtonEvents();
    setupCategoryChoiceButtonEvents();
    setupCongratulationsButtonEvents();
    setupResultsButtonEvents();
    
    
    $('.stage-milestone .debugBtn').click(function() {      
        completeAllEventGroups();
    });
    
     $('.stage-categorySelection .debugBtn').click(function() {
        
        selectedCategoriesIndexes = [];
        for (var i = 0; i < categoriesListArray.length; i++) {       
            selectedCategoriesIndexes.push(categoriesListArray[i].choices.length-1);
            
             updateCurrentStatChangeValues(
            0,
            0,
            categoriesListArray[i].choices[categoriesListArray[i].choices.length-1].wellbeingChange,
            categoriesListArray[i].choices[categoriesListArray[i].choices.length-1].price);

        }
        checkIfAllCategoriesComplete(); 
    });
    
});


/* Progress bar
–––––––––––––––––––––––––––––––––––––––––––––––––– */

function createProgressBarEventGroupMarkers(){
  //  console.log("createProgressBarEventGroupMarkers:" + eventGroupListArray.length);
    $("#progressBar-milestones ul").empty();
    totalProgressStep = 0;
    //add one for the start
    $("#progressBar-milestones ul").append('<li></li>');
    for(var i=0; i< eventGroupListArray.length-1 ; i++){
        $("#progressBar-milestones ul").append('<li><div class ="halfCircleLeft"/><div class ="halfCircleRight"/></li>');

  //      console.log(eventGroupListArray[i].events.length);
        totalProgressStep += eventGroupListArray[i].events.length;
    }
    //add one more for the end marker
    $("#progressBar-milestones ul").append('<li></li>');
}

function calculateProgressBarStepValues(){
    progressStepValues = [];
    for(var i=0; i< eventGroupListArray.length ; i++){
        for(var j = 0; j < eventGroupListArray[i].events.length; j++){

            var mileStoneValue = i*(1.0/eventGroupListArray.length)*100;
            var eventValue = (j*(1.0/eventGroupListArray[i].events.length)) *  (1.0/eventGroupListArray.length) * 100;
            var stepValue = mileStoneValue + eventValue;
            progressStepValues.push(stepValue);
        }
    }
    progressStepValues.push(100);

  //  console.log(progressStepValues);
}

function showProgressBar(){	
    setTimeout(
        function() 
        {
            $("#progressBar-container").removeClass("hidden");
        }, 500);
}

function hideProgressBar(){
    $("#progressBar-container").addClass("hidden");
}

function setProgress(currentStep){
    currentProgressStep = currentStep;
    updateProgressBar();
}

function updateProgressBar(){
   // console.log("updateProgressBar:" + progressStepValues[currentProgressStep-1]);

    animateProgressBar(progressStepValues[currentProgressStep-1],progressStepValues[currentProgressStep]);
}

function animateProgressBar(prevAmount,amount){
    prevAmount = prevAmount?prevAmount:0;
    amount = amount?amount:0;

    var width = prevAmount;
    var id = setInterval(frame, 10);

    function frame() {
        if (width >= amount) {
            $(progressBar).width(amount + '%');
            clearInterval(id);

        } else {
            width++; 
            $(progressBar).width(width + '%');
        }
    }
}

/* Page Stats 
–––––––––––––––––––––––––––––––––––––––––––––––––– */
function setBudget(newBudget){
    budget = newBudget;

    updateStatsDisplay();
}

function updateCurrentStatChangeValues(savingsChange,kiwisaverChange,wellbeingChange,totalSpendChange){
    currentChangeSavings += parseFloat(savingsChange);
    currentChangeKiwisaver += parseFloat(kiwisaverChange);
    currentChangeWellbeing += parseFloat(wellbeingChange);

    currentChangeTotalSpend += parseFloat(totalSpendChange);

    showTempStatsChanges();
}

function resetCurrentStatChangeValues(){
    //console.log("resetCurrentChangeValues");
    currentChangeSavings = 0;
    currentChangeKiwisaver = 0;
    currentChangeWellbeing = 0;

    currentChangeTotalSpend = 0;

    updateStatsDisplay();
}

function confirmStatsChange(){
    currentSavings += currentChangeSavings;
    currentKiwisaver += currentChangeKiwisaver;
    currentWellbeing += currentChangeWellbeing;

    totalSpend += currentChangeTotalSpend;

    resetCurrentStatChangeValues();
}

function updateStatsDisplay(){
    //Savings
     $('.pageStatGroup.savings .pageStatValue h4').html(currencyFormatter.format(currentSavings));
    
    //KiwiSaver
    $('.pageStatGroup.kiwisaver .pageStatValue h4').html(currencyFormatter.format(currentKiwisaver));

    //Wellbeing
    var widthPercent;
    widthPercent = (currentWellbeing / maxWellbeingLevel) * 100;
    $('.pageStatGroup.wellbeing .barGraph .front').width(widthPercent + "%");
    $('.pageStatGroup.wellbeing .back').width(widthPercent + "%");

    $('#wellbeingStat .barGraph .front').width(widthPercent + "%");
    $('#wellbeingStat .barGraph .back').width(widthPercent + "%");

    $('#budgetStat .barValueText').html(currencyFormatter.format((budget-totalSpend)) + " per week");
    
    //Colour budget red if negtive
    if((budget-totalSpend)<0){
        $('#budgetStat .barValueText').addClass("overSpend");
        $('#budgetStat .barTitle').addClass("overSpend");
    }
    else{
        $('#budgetStat .barValueText').removeClass("overSpend");
        $('#budgetStat .barTitle').removeClass("overSpend");
    }

    widthPercent = (100 - (totalSpend / budget) * 100);
    $('#budgetStat .barGraph .front').width(widthPercent + "%");
    $('#budgetStat .barGraph .back').width(widthPercent + "%");

}

function showTempStatsChanges(){
    //Savings
    $('.pageStatGroup.savings .pageStatValue h4').html(currencyFormatter.format((currentSavings+currentChangeSavings)));
    calculateStatsIncreaseOrDecrease(currentChangeSavings,'.pageStatGroup.savings .changeIndicator');

    //KiwiSaver
    $('.pageStatGroup.kiwisaver .pageStatValue h4').html(currencyFormatter.format(currentKiwisaver+currentChangeKiwisaver));
    calculateStatsIncreaseOrDecrease(currentChangeKiwisaver,'.pageStatGroup.kiwisaver .changeIndicator');

    //Wellbeing
    var updatedWidthPercent = ((currentWellbeing+currentChangeWellbeing) / maxWellbeingLevel) * 100;
    var oldWidthPercent = (currentWellbeing / maxWellbeingLevel) * 100;
    calculateChangeToStatsBar(-currentChangeWellbeing,oldWidthPercent,updatedWidthPercent,'.pageStatGroup.wellbeing .barGraph');
    calculateChangeToStatsBar(-currentChangeWellbeing,oldWidthPercent,updatedWidthPercent,'#wellbeingStat .barGraph');
    calculateStatsIncreaseOrDecrease(currentChangeWellbeing,'.pageStatGroup.wellbeing .changeIndicator');


    $('#budgetStat .barValueText').html(currencyFormatter.format(budget-(totalSpend+currentChangeTotalSpend)) + " per week");
    
    updatedWidthPercent = (100 - ((totalSpend+currentChangeTotalSpend) / budget) * 100);
    oldWidthPercent = (100 - (totalSpend / budget) * 100);
    calculateChangeToStatsBar(currentChangeTotalSpend,oldWidthPercent,updatedWidthPercent,'#budgetStat .barGraph');


}

function calculateChangeToStatsBar(valueChange, oldWidth, updatedWidth, divParent){

    var frontBarDiv = $(divParent).find('.front');
    var backBarDiv = $(divParent).find('.back');

    if(valueChange>0){
        $(backBarDiv).removeClass("increase");
        $(backBarDiv).addClass("decrease");

        $(backBarDiv).width(oldWidth + "%");
        $(frontBarDiv).width(updatedWidth + "%");
    }
    else if(valueChange<0){
        $(backBarDiv).removeClass("decrease");
        $(backBarDiv).addClass("increase");

        $(backBarDiv).width(updatedWidth + "%");
        $(frontBarDiv).width(oldWidth + "%");
    }
    else{
        $(backBarDiv).width(updatedWidth + "%");
        $(frontBarDiv).width(updatedWidth + "%");
    }
}

function calculateStatsIncreaseOrDecrease(valueChange, divParent){
    var classToAdd;
    
    if(valueChange>0){
        classToAdd = "increaseValue";
        $(divParent).removeClass("increaseValue decreaseValue").addClass(classToAdd);
    }
    else if(valueChange<0){
        classToAdd = "decreaseValue";
        $(divParent).removeClass("increaseValue decreaseValue").addClass(classToAdd);
    }
    else{
        $(divParent).removeClass("increaseValue decreaseValue");
    }
}

function printCurrentStatValues(){
    console.log("currentSavings:" + currentSavings + 
                "\n currentKiwisaver: " + currentKiwisaver + 
                "\n currentWellbeing: " + currentWellbeing);
}

function printCurrentStatChangeValues(){
    console.log("currentChangeSavings:" + currentChangeSavings + 
                "\n currentChangeKiwisaver: " + currentChangeKiwisaver + 
                "\n currentChangeWellbeing: " + currentChangeWellbeing);
}




/* Stats Bars
–––––––––––––––––––––––––––––––––––––––––––––––––– */

function showStatsBar(){	
    setTimeout(
        function() 
        {
            $("#topStatsBar").removeClass("hidden");
        }, 500);
}

function hideStatsBar(){
    $("#topStatsBar").addClass("hidden");
}

/* Milestone JSON loading
–––––––––––––––––––––––––––––––––––––––––––––––––– */
function loadEventGroupJSON(path){
    var jqxhr = $.getJSON( path, function(data) {
        //console.log( "loadEventsJSON - success" );
        eventGroupListJSON = data;
    })
    .done(function() {
        //console.log( "second success: " + eventGroupListJSON.length);
        eventGroupListArray = buildEventGroupListArray(eventGroupListJSON);

        //printEventsForEventGroup(0);
        setupEventGroups();
    })
    .fail(function() {
        console.log( "JSON error: loadEventGroupJSON" );
    })
    .always(function() {
    });
}

function buildEventGroupListArray(listJSON){
    var totalItemsCount = listJSON.length;
    var tempItemList = [];

    for(var i = 0; i<totalItemsCount; i++){
        var item = createEventGroupObject(listJSON[i]);
        tempItemList.push(item);
    }
    return tempItemList;
}

function createEventGroupObject(itemJSON){
    var item = new Object();

    item.events = itemJSON.events;
    item.intro = itemJSON.intro;
    item.outro = itemJSON.outro;

    return item;
}

function printEventsForEventGroup(eventGroupIndex){
    console.log("printEventsForEventGroup: " + eventGroupIndex);
    for(var i = 0; i < eventGroupListArray[eventGroupIndex].events.length; i++){
        console.log(eventGroupListArray[eventGroupIndex].events[i]);
    }
}

/* Budget Categories JSON loading
–––––––––––––––––––––––––––––––––––––––––––––––––– */
function loadBudgetCategoriesJSON(path){
    var jqxhr = $.getJSON( path, function(data) {
        //console.log( "loadBudgetCategoriesJSON - success" );
        categoriesListJSON = data;
    })
    .done(function() {
        //console.log( "second success: " + categoriesListJSON.length);
        categoriesListArray = buildCategoriesListArray(categoriesListJSON);

        buildCategorySelectionGrid(".stage-categorySelection .item-container-large",categoriesListArray,"selectCategory(this)");

    })
    .fail(function() {
        console.log( "JSON error: categories" );
    })
    .always(function() {
    });
}

function buildCategoriesListArray(listJSON){
    var totalItemsCount = listJSON.length;
    var tempItemList = [];

    for(var i = 0; i<totalItemsCount; i++){
        var item = createCategoryObject(listJSON[i]);
        tempItemList.push(item);
    }
    return tempItemList;
}

function createCategoryObject(itemJSON){
    var item = new Object();

    item.name = itemJSON.name;
    item.description = itemJSON.description;
    item.imgPath = itemJSON.imgPath;
    item.choices = itemJSON.choices;

    return item;
}

/* 0: Setup
–––––––––––––––––––––––––––––––––––––––––––––––––– */
function reset(){
    setupStartingStats();

    salaryStarting = 0;
    salaryCurrent = 0;
    salarySavingPercent = 0;
    kiwisaverContributionPercent = 0;
    
    budget = 0;
    totalSpend = 0;
    currentChangeTotalSpend = 0;

    currentEventGroup = 0;
    currentEventInEventGroup = 0;
    currentEventPageName = ".stage-eventChoice-1";

    eventChoiceChangesUsed = 0;
    currentSelectedEventChoice = null;
    trackedChoices = [];

    warningChoiceSavingsCount = 0;
    warningChoiceKiwisaverCount = 0;
    warningChoiceWellbeingCount = 0;

    setProgress(0);
    showProgressBar();

}

function setupStartingStats(){
    currentSavings = parseFloat(startingSavings);
    currentKiwisaver = parseFloat(startingKiwisaver);
    currentWellbeing = parseFloat(startingWellbeing);

    resetCurrentStatChangeValues();
}

function setupEventGroups(){
   // console.log("eventGroupListArray.length:" + eventGroupListArray.length);
    currentEventGroup = 0;
    currentEventInEventGroup = 0;

    createProgressBarEventGroupMarkers();
    calculateProgressBarStepValues();

    loadCurrentEventGroup();
}



/* 1: Milestone screen
–––––––––––––––––––––––––––––––––––––––––––––––––– */
function setupMilestoneButtonEvents(){
    $('.stage-milestone .stageNavBtn').click(function() {        
        closeMilestoneScreen();
    });

}

function loadCurrentEventGroup(){
    //console.log("loadCurrentEventGroup: " + currentEventGroup);

    //check if currentEventGroup has intro screen
    if(eventGroupListArray[currentEventGroup].intro != null){
        //console.log("has introScreen");
        loadIntroScreen();
    }
    else{
        //console.log("doesn't have introScreen");
        //Go to either page 2 or 3
        let nextEventTriggerBtn = $('.openEventBtn');
        let whichEventScreen = ((currentEventInEventGroup+2)%2)+2;
        nextEventTriggerBtn.data('goto',whichEventScreen);
        //console.log("whichEventScreen:" + whichEventScreen);
        $('.openEventBtn').click();

    }



    // updateMilestoneText();
    updateMilestoneStats();

    currentEventInEventGroup = 0;
    currentEventPageName = ".stage-eventChoice-1";
            $(currentEventPageName).find('.container-scroller').scrollTop(0);

    loadCurrentEvent();
}

function loadIntroScreen(){
    var tempName = eventGroupListArray[currentEventGroup].intro.name;
    var tempDescription = eventGroupListArray[currentEventGroup].intro.description;
    var tempImgPath = eventGroupListArray[currentEventGroup].intro.imgPath;

    updateMilestoneDetails(tempName, tempDescription, tempImgPath);
    $('.openMilestoneBtn').click();
    $('.stage-milestone').find('.container-scroller').scrollTop(0);
}

function loadOutroScreen(){
    var tempName = eventGroupListArray[currentEventGroup].outro.name;
    var tempDescription = eventGroupListArray[currentEventGroup].outro.description;
    var tempImgPath = eventGroupListArray[currentEventGroup].outro.imgPath;

    updateMilestoneDetails(tempName, tempDescription, tempImgPath);

    if(eventGroupListArray[currentEventGroup].outro.timePassedInYears){
        calculatePerAnnumChangesForMilestone(eventGroupListArray[currentEventGroup].outro.timePassedInYears);
    }
    else{
        updateCurrentStatChangeValues(
        0,
        0,
        0,
        0);
    }

    $('.openMilestoneBtn').click();
    $('.stage-milestone').find('.container-scroller').scrollTop(0);

}


function updateMilestoneDetails(name, description, imgPath){
    $('.stage-milestone .details .title').html(name);
    $('.stage-milestone .details .description').html(description);
    $('.stage-milestone .details .image').attr("src",imgPath);

    insertCurrentChoiceDetails();
}

function insertCurrentChoiceDetails(){
    $('.currentChoiceTitle').html(eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].choices[currentSelectedEventChoice].name);
}

function calculatePerAnnumChangesForMilestone(yearsPassed){
    updateCurrentStatChangeValues(
        0,
        0,
        0,
        0);
    
    var tempSavingsChange = 0;
    var tempKiwisaverChange = 0;

    for(var i=0; i<yearsPassed; i++){
        salaryCurrent = salaryCurrent + (salaryCurrent*perAnnumSalaryIncreasePercent);
        
        tempSavingsChange = salaryCurrent * salarySavingPercent;
        
        tempKiwisaverChange = (salaryCurrent * kiwisaverContributionPercent) + (salaryCurrent * 0.03); 

        
        updateCurrentStatChangeValues(
        tempSavingsChange,
        tempKiwisaverChange,
        0,
        0);
    }
}

function updateMilestoneStats(){
    confirmStatsChange();
}

function closeMilestoneScreen(){
    updateMilestoneStats();

    //is there an event next (was this the intro)
    if((currentEventInEventGroup+1) < eventGroupListArray[currentEventGroup].events.length){
        //Just transition to the event screen
        let nextEventTriggerBtn = $('.openEventBtn');
        let whichEventScreen = ((currentEventInEventGroup+2)%2)+2;
        nextEventTriggerBtn.data('goto',whichEventScreen);
        $('.openEventBtn').click();
    }
    else{
        completeEventGroup();
    }
}



/* 2+3: Event Choice (and event outcome if no choice)
–––––––––––––––––––––––––––––––––––––––––––––––––– */
function setupEventChoiceButtonEvents(){
    $('.stage-eventChoice .confirmBtn').click(function() {        
        loadEventResults();
    });

    $('.stage-eventChoice .outcomeConfirmBtn').click(function() {   
        confirmStatsChange();
        completeEvent();
    });
}

function loadCurrentEvent(){
    currentSelectedEventChoice = null;

    updateEventStyle();
    updateEventChoiceDetails();

    setupEventType();
}

function setupEventType(){
    var eventType = eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].type? eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].type: "choice";

    let gridParent = currentEventPageName + " .item-container-large";


    switch(eventType){
        case "choice":
//            console.log("eventType:" + eventType);

            updateEventChoiceDetails();

            $(gridParent).show();
            
            buildEventChoiceGrid(gridParent,eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].choices,"selectEventChoice(this)",eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].numberOfChoiceTitleLines);
            applyStyleGridItemsIfPrerequisitesMet(gridParent,eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].choices,"unselectable",false);

            $(currentEventPageName).find('.choiceSection').show();
            $(currentEventPageName).find('.outcomeSection').hide();
            $(currentEventPageName).find('.statsSection').hide();
            
            break;

        case "hiddenChoice":
//            console.log("eventType:" + eventType);

            updateEventChoiceDetails();

            $(gridParent).show();
            buildEventChoiceGrid(gridParent,eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].choices,"selectEventChoice(this)",eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].numberOfChoiceTitleLines);
            
            applyStyleGridItemsIfPrerequisitesMet(gridParent,eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].choices,"hidden",false);
            removeAllHiddenGridItems(gridParent);
            
        
            $(currentEventPageName).find('.choiceSection').show();
            $(currentEventPageName).find('.outcomeSection').hide();
            $(currentEventPageName).find('.statsSection').hide();
            break;

        case "outcome":
//            console.log("eventType:" + eventType);
            $(gridParent).hide();
            
            currentSelectedEventChoice = selectOutcomeByPrerequisites(eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].choices);
            
            updateEventOutcomeDetails();

            calculateStatChangeFromSelectedEventChoice();

            $(currentEventPageName).find('.choiceSection').hide();
            $(currentEventPageName).find('.outcomeSection').show();
            $(currentEventPageName).find('.statsSection').show();
            break;

                    }
}

function updateEventChoiceDetails(){
    $(currentEventPageName).find('.eventTitle').html(eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].name);
    $(currentEventPageName).find('.eventDescription').html(eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].description);

    $(currentEventPageName).find(".eventImage").attr("src",eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].imgPath);
}

function updateEventOutcomeDetails(){
    $(currentEventPageName).find('.outcomeTitle').html(eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].choices[currentSelectedEventChoice].name);
    $(currentEventPageName).find('.outcomeResult').html(eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].choices[currentSelectedEventChoice].resultText);
    $(currentEventPageName).find('.outcomeImage').attr("src",eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].choices[currentSelectedEventChoice].imgPath);
}

function updateEventStyle(){
    var eventStyle = eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].style? eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].style: null;

    let targetContainerScroller = currentEventPageName + " .container-scroller";
    $(targetContainerScroller).removeClass("eventStyle-event");
    $(targetContainerScroller).removeClass("eventStyle-crisis");

    switch(eventStyle){
        case "default":
//            console.log("updateEventStyle:" + eventStyle);
            $(targetContainerScroller).addClass("eventStyle-event");
            break;
        case "crisis":
//            console.log("updateEventStyle:" + eventStyle);
            $(targetContainerScroller).addClass("eventStyle-crisis");
            break;

                     }
}

function buildEventChoiceGrid(parentDiv, itemListArray, clickEvent, numberOfCardTitleLines){
    var itemGridHtml = '<div class="item-grid"></div>';
    var thisItemGridParent;

    if( $(parentDiv).find(".item-grid").length){
    }
    else{
        $(parentDiv).append(itemGridHtml);
    }

    thisItemGridParent = $(parentDiv).find(".item-grid");
    $(thisItemGridParent).empty();

    for (var i = 0; i < itemListArray.length; i++) {
        $(thisItemGridParent).append(createEventChoiceCard(i,itemListArray[i],clickEvent,numberOfCardTitleLines));
    }

}

function createEventChoiceCard(itemIndex, item, clickEvent, numberOfTitleLines){
    let titleClass = "singleLineTitle";
    
    switch(numberOfTitleLines){
        case 1:
            titleClass = "singleLineTitle";
        break;
            
        case 2:
            titleClass = "doubleLineTitle";
        break;
    }
    
    let itemDescriptionHTML = "";
    
    if(item.description){
        itemDescriptionHTML += '<h6 class ="description">'+item.description+'</h6>';
    }

    var itemHtml = '<div class="item" data-index="'+ itemIndex +'" onclick="'+clickEvent+'">' +
        '<img src="'+item.imgPath+'"></img>' +
        '<h6 class ="title '+ titleClass +'">'+item.name+'</h6>' +
        itemDescriptionHTML +
        '</div>';
    return $(itemHtml);
}

function selectEventChoice(button){
    //console.log("selectEventChoice");

    var itemCard = $(button).closest(".item");
    var index = $(itemCard).data("index");

    currentSelectedEventChoice = index;
    calculateStatChangeFromSelectedEventChoice();

    let gridParent = currentEventPageName + " .item-grid";
    highlightSelectedLargeItemCard(gridParent,currentSelectedEventChoice);

    //printCurrentStatChangeValues();

    $(currentEventPageName).find('.confirmBtn').click();

}

function calculateStatChangeFromSelectedEventChoice(){
    var currentChoice = eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].choices[currentSelectedEventChoice];

    var tempSavingsChange = 0;
    var tempKiwisaverChange = 0;
    var tempWellbeingChange = 0;

    var savingsChangeType = currentChoice.savingsChangeType?currentChoice.savingsChangeType:null;

    if(savingsChangeType){
        switch(savingsChangeType){
            case "flatAmount":
                tempSavingsChange = currentChoice.savingsChange;
                break;

            case "percent":
                tempSavingsChange = Math.abs(currentSavings) * (currentChoice.savingsChange/100.0);
                break;

            case "salaryPercent":
                salarySavingPercent = currentChoice.savingsChange/100.0;
                
                tempSavingsChange = salaryCurrent * salarySavingPercent;
                
//                tempSavingsChange = salaryCurrent * (currentChoice.savingsChange/100.0); 
                break;

            case "setValue":
                if(currentSavings>0){
                    //console.log("setValue +");
                    tempSavingsChange = parseFloat(currentChoice.savingsChange) - currentSavings;
                }
                else{
                    //console.log("setValue -: currentSavings:" + currentSavings);
                    tempSavingsChange = parseFloat(currentChoice.savingsChange) + Math.abs(currentSavings);
                    //console.log("changeValue" + tempSavingsChange);

                }
                break;
                                }
    }

    var kiwisaverChangeType = currentChoice.kiwisaverChangeType?currentChoice.kiwisaverChangeType:null;

    if(kiwisaverChangeType){
        switch(kiwisaverChangeType){
            case "flatAmount":
                tempKiwisaverChange = currentChoice.kiwisaverChange;
                break;

            case "percent":
                tempKiwisaverChange = Math.abs(currentKiwisaver) * (currentChoice.kiwisaverChange/100.0);
                break;

            case "salaryPercent":
                kiwisaverContributionPercent = currentChoice.kiwisaverChange/100.0;
                tempKiwisaverChange = (salaryCurrent * kiwisaverContributionPercent) + (salaryCurrent * 0.03); 
                break;

            case "setValue":
                if(currentKiwisaver>0){
                    tempKiwisaverChange = currentChoice.kiwisaverChange - currentKiwisaver;
                }
                else{
                    tempKiwisaverChange = currentChoice.kiwisaverChange + Math.abs(currentKiwisaver);
                }
                break;
                                  }
    }

    if(currentChoice.wellbeingChange){
        tempWellbeingChange = currentChoice.wellbeingChange;
    }

    updateCurrentStatChangeValues(
        tempSavingsChange,
        tempKiwisaverChange,
        tempWellbeingChange,
        0);

    if(currentChoice.salary){
        salaryStarting += parseFloat(currentChoice.salary);
        if(salaryCurrent == 0){
            salaryCurrent = salaryStarting;
        }
    }

}


function highlightSelectedLargeItemCard(parentDiv,selectedIndex){
    for (var i = 0; i < $(parentDiv).find(".item").length; i++) {
        if(i == selectedIndex){
            $(parentDiv).find(".item").eq(i).addClass("selected");
        }
        else{
            $(parentDiv).find(".item").eq(i).removeClass("selected");
        }
    }
}

function applyStyleGridItemsIfPrerequisitesMet(parentDiv, itemListArray, cssStyle, addIfMet){
    //console.log("applyStyleGridItemsIfPrerequisitesMet");
    var thisItemGridParent;
    thisItemGridParent = $(parentDiv).find(".item-grid");

    for (var i = 0; i < itemListArray.length; i++) {
        if(itemListArray[i].prerequisites){
            var prereqMet = false;
            //console.log(i + " has prerequisites: " + itemListArray[i].prerequisites);
            //Each possible prereq condition
            for(var j=0; j<itemListArray[i].prerequisites.length; j++){
                //Each element of that condition
                if(arrayContainsAllElements(itemListArray[i].prerequisites[j],trackedChoices)){
                    prereqMet = true;
                    break;
                }
            }
            
            if(prereqMet && addIfMet){
                $(thisItemGridParent).children().eq(i).addClass(cssStyle);
            }
            else if(!prereqMet && !addIfMet){
                $(thisItemGridParent).children().eq(i).addClass(cssStyle);
            }
        }
        else             if(itemListArray[i].minSavingsPrerequisite){
                if(currentSavings < itemListArray[i].minSavingsPrerequisite){
                    $(thisItemGridParent).children().eq(i).addClass(cssStyle);
                }
            }
        else{
            //console.log(i + " no prerequisites");
        }
    }
}

function removeGridItemsIfPrerequisitesNotMet(parentDiv, itemListArray){
    //console.log("applyStyleGridItemsIfPrerequisitesMet");
    var thisItemGridParent;
    thisItemGridParent = $(parentDiv).find(".item-grid");

    for (var i = 0; i < itemListArray.length; i++) {
        if(itemListArray[i].prerequisites){
            var prereqMet = false;
            //console.log(i + " has prerequisites: " + itemListArray[i].prerequisites);
            //Each possible prereq condition
            for(var j=0; j<itemListArray[i].prerequisites.length; j++){
                //Each element of that condition
                if(arrayContainsAllElements(itemListArray[i].prerequisites[j],trackedChoices)){
                    prereqMet = true;
                    break;
                }
            }
            
            if(!prereqMet){
                //This can't remove children by i, it's inaccurate as soon as one elment is removed.
                $(thisItemGridParent).children().eq(i).remove();

            }
        }
        else{
            //console.log(i + " no prerequisites");
        }
    }
}

function removeAllHiddenGridItems(parentDiv){
    var thisItemGridParent;
    thisItemGridParent = $(parentDiv).find(".item-grid");
    
    $(thisItemGridParent).find(".hidden").each(function(){
        $(this).remove();
    })
}

function selectOutcomeByPrerequisites(itemListArray){
    var tempChoice;

    var prereqMet = false;
    for (var i = 0; i < itemListArray.length; i++) {
        for(var j=0; j<itemListArray[i].prerequisites.length; j++){
            //Each element of that condition
            if(arrayContainsAllElements(itemListArray[i].prerequisites[j],trackedChoices)){
                prereqMet = true;
                tempChoice = i;
                break;
            }
        }
        if(prereqMet){break;}
    }

    return tempChoice;

}

function arrayContainsAllElements(elements,array){
    for(var i = 0; i < elements.length; i++){
        if($.inArray(elements[i], array) == -1) return false;
    }
    return true;
}

function buildEventStatsBars(parentDiv){

}

/* 4: Event Result 
–––––––––––––––––––––––––––––––––––––––––––––––––– */
function setupEventResultButtonEvents(){
//    $('.eventResult-modal .confirmBtn').click(function() {
//        confirmStatsChange();
//        completeEvent();
//    });
    
    $('.eventResult-modal .confirmBtn').on('click touchstart',function(){
        confirmStatsChange();
        completeEvent();
    
    });

    $('.eventResult-modal .cancelBtn').click(function() {

    });


    $('.eventResult-modal .savings .warningBtn').click(function() {
        updateEventResultWarningText("Better watch your Savings","Your savings amount at the moment is very low! If you haven’t used an opportunity to go back and change your choices we strongly recommend you to go back and change your choices to increase your saving amount. With the future events, please consider choosing an option that doesn’t decrease your savings too much.");
    });

    $('.eventResult-modal .kiwisaver .warningBtn').click(function() {
        updateEventResultWarningText("Better watch your KiwiSaver","Your KiwiSaver amount at the moment is very low! If you haven’t used an opportunity to go back and change your choices we strongly recommend you to go back to your KiwiSaver selection event and increase the contribution rate. With the future events, please consider choosing an option that will increase your KiwiSaver investing amount.");
    });

    $('.eventResult-modal .wellbeing .warningBtn').click(function() {
        updateEventResultWarningText("Better watch your Wellbeing","Your wellbeing score at the moment is very low! Please remember having a good level of wellbeing is important in your life long journey. Please consider choices that you think will make you happier.");
    });

    $('.eventResult-changeChoiceModal .cancelBtn').click(function() {
    });

//    $('.eventResult-changeChoiceModal .confirmBtn').click(function() {
        $('.eventResult-changeChoiceModal .confirmBtn').on('click touchstart',function(){
        eventChoiceChangesUsed++;

        //Reset current choice selection
        //        if(eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].choices[currentSelectedEventChoice].warnings != null){
        //        removeWarningCount( eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].choices[currentSelectedEventChoice].warnings);
        //        }


        currentSelectedEventChoice = null;
        let gridParent = currentEventPageName + " .item-grid";
        highlightSelectedLargeItemCard(gridParent,currentSelectedEventChoice);
        resetCurrentStatChangeValues();



        $('.eventResult-modal .backBtn').click();
    });
}

function loadEventResults(){
    updateEventResultsDetails();

    checkIfEventChoiceChangeAllowed();
    // checkIfChoiceWarningShown();

    var warningArray = eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].choices[currentSelectedEventChoice].warnings? eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].choices[currentSelectedEventChoice].warnings: [];

    checkIfChoiceWarningShown(warningArray);
}

function updateEventResultsDetails(){
    $('.eventResult-modal .choiceTitle').html(eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].choices[currentSelectedEventChoice].name);
    $('.eventResult-modal .choiceResult').html(eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].choices[currentSelectedEventChoice].resultText);

    $(".eventResult-modal .choiceImage").attr("src",eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].choices[currentSelectedEventChoice].imgPath);

}

function updateEventResultWarningText(warningTitle, warningText){
    $('.eventResult-warningModal .header h4').text(warningTitle);
    $('.eventResult-warningModal .warningCopy').text(warningText);
    
}


function checkIfChoiceWarningShown(warningObject){
    warningChoiceSavingsCountChange = warningChoiceSavingsCount;
    warningChoiceKiwisaverCountChange = warningChoiceKiwisaverCount;
    warningChoiceWellbeingCountChange = warningChoiceWellbeingCount;

    if(warningObject.includes("savings")){
        warningChoiceSavingsCountChange++;
    }
    else{
        warningChoiceSavingsCountChange = 0;
    }

    if(warningObject.includes("kiwisaver")){
        warningChoiceKiwisaverCountChange++;
    }
    else{
        warningChoiceKiwisaverCountChange = 0;
    }

    if(warningObject.includes("wellbeing")){
        warningChoiceWellbeingCountChange++;
    }
    else{
        warningChoiceWellbeingCountChange = 0;
    }

    if(warningChoiceSavingsCountChange >= maxConsecutiveChoicesForWarning){
        $('.eventResult-modal .savings .warningArea').removeClass("hideWarningArea");
        $('.stage-eventChoice .savings .warningArea').removeClass("hideWarningArea");
        
    }
    else{
        $('.eventResult-modal .savings .warningArea').addClass("hideWarningArea");
        $('.stage-eventChoice .savings .warningArea').addClass("hideWarningArea");
    }

    if(warningChoiceKiwisaverCountChange >= maxConsecutiveChoicesForWarning){
        $('.eventResult-modal .kiwisaver .warningArea').removeClass("hideWarningArea");
        $('.stage-eventChoice .kiwisaver .warningArea').removeClass("hideWarningArea");
    }
    else{
        $('.eventResult-modal .kiwisaver .warningArea').addClass("hideWarningArea");
        $('.stage-eventChoice .kiwisaver .warningArea').addClass("hideWarningArea");
    }

    if(warningChoiceWellbeingCountChange >= maxConsecutiveChoicesForWarning){
        $('.eventResult-modal .wellbeing .warningArea').removeClass("hideWarningArea");
        $('.stage-eventChoice .wellbeing .warningArea').removeClass("hideWarningArea");
    }
    else{
        $('.eventResult-modal .wellbeing .warningArea').addClass("hideWarningArea");
        $('.stage-eventChoice .wellbeing .warningArea').addClass("hideWarningArea");
    }
}

function confirmChoiceWarningCount(){
    warningChoiceSavingsCount = warningChoiceSavingsCountChange;
    warningChoiceKiwisaverCount = warningChoiceKiwisaverCountChange;
    warningChoiceWellbeingCount = warningChoiceWellbeingCountChange;
}

function checkIfEventChoiceChangeAllowed(){
    if(eventChoiceChangesUsed < eventChoiceChangesAllowed){
        $('.eventResult-modal .cancelBtn').removeClass("disabled");
    }
    else{
        $('.eventResult-modal .cancelBtn').addClass("disabled");
    }
}

function completeEvent(){

    confirmChoiceWarningCount();

    trackEventChoice();

    //SET THE PROGRESS BAR PROPERLY
    setProgress( currentProgressStep + 1);

    if((currentEventInEventGroup+1) < eventGroupListArray[currentEventGroup].events.length){

        loadNextEvent();
    }
    else{
        completeAllEventsInGroup();
    }
}

function trackEventChoice(){
    trackedChoices.push(eventGroupListArray[currentEventGroup].events[currentEventInEventGroup].choices[currentSelectedEventChoice].id);

}

function loadNextEvent(){
    let nextEventTriggerBtn = $('.stage-eventResult .goNextEventBtn');

    currentEventInEventGroup++;

    //Go to either page 2 or 3
    let whichEventScreen = ((currentEventInEventGroup+2)%2)+2;
    nextEventTriggerBtn.data('goto',whichEventScreen);
    //console.log("whichEventScreen:" + whichEventScreen);
    if(whichEventScreen == 2){
        currentEventPageName = ".stage-eventChoice-1";
    }
    else{
        currentEventPageName = ".stage-eventChoice-2";
    }

    loadCurrentEvent();
    $('.stage-eventResult .goNextEventBtn').click();
    $(currentEventPageName).find('.container-scroller').scrollTop(0);
}

function completeAllEventsInGroup(){
    //check if currentEventGroup has outrp screen
    if(eventGroupListArray[currentEventGroup].outro != null){
        //console.log("has outroScreen");
        loadOutroScreen();
    }
    else{
        //console.log("doesn't have outroScreen");
        completeEventGroup();
    }
}

function completeEventGroup(){
    if( (currentEventGroup+1) < eventGroupListArray.length ){
        loadNextEventGroup();
    }
    else{
        completeAllEventGroups();
    }
}

function loadNextEventGroup(){
    currentEventInEventGroup = 0;
    currentEventGroup++;
    loadCurrentEventGroup();
    // $('.stage-eventResult .goNextMilestoneBtn').click();
}


/* 5: End of Milestones
–––––––––––––––––––––––––––––––––––––––––––––––––– */
function completeAllEventGroups(){
    updateSavingsTotals();
    $('.stage-eventResult .finishMilestonesBtn').click();
}

/* 6: Budget Calculation
–––––––––––––––––––––––––––––––––––––––––––––––––– */
function setupBudgetCalculationButtonEvents(){
    $('.stage-budgetCalculation .confirmBtn').click(function() {
        categorySelectionSetup();
    });
}

function updateSavingsTotals(){
    totalSavings = currentSavings + currentKiwisaver;
    setBudget( (totalSavings/1560) + superPerWeek );

    updateBudgetCalculationText();
}

function updateBudgetCalculationText(){
//    $('.calculationArea .savingsValue').html(currentSavings.toFixed(2));
//    $('.calculationArea .kiwisaverValue').html(currentKiwisaver.toFixed(2));
//    $('.calculationArea .totalSavingsValue').html(totalSavings.toFixed(2));
//
//    $('.calculationArea .savingsPerWeekValue').html( (totalSavings/1560).toFixed(2) );
//    $('.calculationArea .superPerWeekValue').html(superPerWeek.toFixed(2) );
//    $('.calculationArea .totalPerWeekValue').html(budget.toFixed(2) );
    
    $('.calculationArea .savingsValue').html(currencyFormatter.format(currentSavings));
    $('.calculationArea .kiwisaverValue').html(currencyFormatter.format(currentKiwisaver));
    $('.calculationArea .totalSavingsValue').html(currencyFormatter.format(totalSavings));

    $('.calculationArea .savingsPerWeekValue').html(currencyFormatter.format(totalSavings/1560));
    $('.calculationArea .superPerWeekValue').html(currencyFormatter.format(superPerWeek));
    $('.calculationArea .totalPerWeekValue').html(currencyFormatter.format(budget));
}

/* 7: Category Selection
–––––––––––––––––––––––––––––––––––––––––––––––––– */

//categoriesListArray;
//selectedCategoriesIndexes = [];
//currentSelectedCategory = null;
function setupCategorySelectionButtonEvents(){
    $('.stage-categorySelection .confirmBtn').click(function() {
//     $(".stage-categorySelection .confirmBtn").on('click touchstart',function(){
        //updateResultsPage();
        //hideStatsBar();
        if( (budget-totalSpend)<0) {
            $('.stage-categorySelection .openOverBudgetModal').click();
        }
        else{
            $('.stage-categorySelection .openCongratulationsModal').click();
        }

    });

    $('.stage-categorySelection .goToResults').click(function() {
        updateResultsPage();
        hideStatsBar();
    });

   
    
    
}

function categorySelectionSetup(){
    showStatsBar();
    hideProgressBar();

    buildCategorySelectionGrid(".stage-categorySelection .item-container-large",categoriesListArray,"selectCategory(this)");

    checkIfAllCategoriesComplete();
}

//build categories grid.
function buildCategorySelectionGrid(parentDiv, itemListArray, clickEvent){
    var itemGridHtml = '<div class="item-grid"></div>';
    var thisItemGridParent;

    if( $(parentDiv).find(".item-grid").length){
    }
    else{
        $(parentDiv).append(itemGridHtml);
    }

    thisItemGridParent = $(parentDiv).find(".item-grid");
    $(thisItemGridParent).empty();

    selectedCategoriesIndexes = [];

    for (var i = 0; i < itemListArray.length; i++) {        $(thisItemGridParent).append(createSelectCategoryCard(i,itemListArray[i],clickEvent));
    selectedCategoriesIndexes.push(null);

                                                   }
    
    highlightCompletedCategories();
}

function createSelectCategoryCard(itemIndex, item, clickEvent){
    var itemHtml = '<div class="category" data-index="'+ itemIndex +'" onclick="'+clickEvent+'">' +
        '<div class="cornerTag">' + 
        '<span class="icon-ui-check"></span>' +
        '<div class="corner">' +
        '<div class="triangle"></div>' +
        '</div>' +
        '</div>' +
        '<div class= "content">' +
        '<img src="'+item.imgPath+'"></img>' +
        '<h6 class ="title">'+item.name+'</h6>' +
        '<h6 class ="choice"></h6>' +
        '<h6 class ="price">-</h6>' +
        '</div>' +
        '</div>';
    return $(itemHtml);
}

function selectCategory(button){
    var itemCard = $(button).closest(".category");
    var index = $(itemCard).data("index");

    currentSelectedCategory = index;

    selectedCategoryChoiceSetup();

    $('.stage-categoryChoice').find('.container-scroller').scrollTop(0);
    $(".goToSelectedCategoryBtn").click();

    hideStatsBar();
}

//enable and disable continue button.
function checkIfAllCategoriesComplete(){
    highlightCompletedCategories();

    var allCategoriesComplete = true;
    for(var i=0; i< selectedCategoriesIndexes.length; i++){
        if (selectedCategoriesIndexes[i] == null){ 
            allCategoriesComplete = false;
            break;
        }
    }

    if(allCategoriesComplete){
        $('.stage-categorySelection .confirmBtn').removeClass("disabled");
    }
    else{
        $('.stage-categorySelection .confirmBtn').addClass("disabled");
    }
}

//highlight slecteded categoires
function highlightCompletedCategories(){
    for(var i=0; i< selectedCategoriesIndexes.length; i++){
        if (selectedCategoriesIndexes[i] != null){ 
            $('.category-container').find(".category").eq(i).addClass("completed");
            $('.category-container').find(".category").eq(i).find(".choice").html(categoriesListArray[i].choices[selectedCategoriesIndexes[i]].name);
//            $('.category-container').find(".category").eq(i).find(".price").html("$"+categoriesListArray[i].choices[selectedCategoriesIndexes[i]].price);
            $('.category-container').find(".category").eq(i).find(".price").html(currencyFormatter.format(categoriesListArray[i].choices[selectedCategoriesIndexes[i]].price));
            
            


        }
        else{
            $('.category-container').find(".category").eq(i).removeClass("completed");
            $('.category-container').find(".category").eq(i).find(".choice").html("No option chosen.");
            $('.category-container').find(".category").eq(i).find(".price").html("-");
        }
    }

}





/* 8: Category Choice
–––––––––––––––––––––––––––––––––––––––––––––––––– */
function setupCategoryChoiceButtonEvents(){
    $('.stage-categoryChoice .cancelBtn').click(function() {
        //console.log(selectedCategoriesIndexes);
        selectedCategoriesIndexes = previousCategoriesIndexes.slice(0);

        //console.log(selectedCategoriesIndexes);
        resetCurrentStatChangeValues();
        checkIfAllCategoriesComplete();

        showStatsBar();
    });

    $('.stage-categoryChoice .confirmBtn').click(function() {

        confirmStatsChange();
        checkIfAllCategoriesComplete();

        showStatsBar();
    });
}

function selectedCategoryChoiceSetup(){
    // previousCategoriesIndexes = selectedCategoriesIndexes;
    previousCategoriesIndexes = selectedCategoriesIndexes.slice(0);


    $('.stage-categoryChoice .instructions h4').html(categoriesListArray[currentSelectedCategory].name);
    $('.stage-categoryChoice .instructions h6').html(categoriesListArray[currentSelectedCategory].description);

    buildSelectedCategoryChoiceGrid(".stage-categoryChoice .item-container-large",categoriesListArray[currentSelectedCategory].choices,"selectCategoryChoice(this)");
    
    applyStyleGridItemsIfPrerequisitesMet(".stage-categoryChoice .item-container-large",categoriesListArray[currentSelectedCategory].choices,"unselectable",false);

    highlightSelectedLargeItemCard(".stage-categoryChoice .item-grid",  selectedCategoriesIndexes[currentSelectedCategory]);
}

//build selected category grid
function buildSelectedCategoryChoiceGrid(parentDiv, itemListArray, clickEvent){
    var itemGridHtml = '<div class="item-grid"></div>';
    var thisItemGridParent;

    if( $(parentDiv).find(".item-grid").length){
    }
    else{
        $(parentDiv).append(itemGridHtml);
    }

    thisItemGridParent = $(parentDiv).find(".item-grid");
    $(thisItemGridParent).empty();

    for (var i = 0; i < itemListArray.length; i++) {        $(thisItemGridParent).append(createSelectedCategoryChoiceCard(i,itemListArray[i],clickEvent));

                                                   }
}

function createSelectedCategoryChoiceCard(itemIndex, item, clickEvent){
    var itemHtml = '<div class="item" data-index="'+ itemIndex +'" onclick="'+clickEvent+'">' +
        '<img src="'+item.imgPath+'"></img>' +
        '<h6 class ="title">'+item.name+'</h6>' +
        '<h6 class ="description">'+item.description+'</h6>' +
        '<h6 class ="price">'+currencyFormatter.format(item.price)+'</h6>' +
        '</div>';
    return $(itemHtml);
}

function selectCategoryChoice(button){
    //console.log("selectCategoryChoiceChoice");

    var itemCard = $(button).closest(".item");
    var index = $(itemCard).data("index");

    //Unselect if same is selected
    if($(itemCard).hasClass("selected")){
        updateCurrentStatChangeValues(
            0,
            0,
            -categoriesListArray[currentSelectedCategory].choices[selectedCategoriesIndexes[currentSelectedCategory]].wellbeingChange,
            -categoriesListArray[currentSelectedCategory].choices[selectedCategoriesIndexes[currentSelectedCategory]].price);
        selectedCategoriesIndexes[currentSelectedCategory] = null;
    }
    else{
        if(selectedCategoriesIndexes[currentSelectedCategory]!=null){
            updateCurrentStatChangeValues(
                0,
                0,
                -categoriesListArray[currentSelectedCategory].choices[selectedCategoriesIndexes[currentSelectedCategory]].wellbeingChange,
                -categoriesListArray[currentSelectedCategory].choices[selectedCategoriesIndexes[currentSelectedCategory]].price);

        }

        selectedCategoriesIndexes[currentSelectedCategory] = index;
        updateCurrentStatChangeValues(
            0,
            0,
            categoriesListArray[currentSelectedCategory].choices[selectedCategoriesIndexes[currentSelectedCategory]].wellbeingChange,
            categoriesListArray[currentSelectedCategory].choices[selectedCategoriesIndexes[currentSelectedCategory]].price);
    }

    highlightSelectedLargeItemCard(".stage-categoryChoice .item-grid",  selectedCategoriesIndexes[currentSelectedCategory]);
}

/* 9: Congratulations
–––––––––––––––––––––––––––––––––––––––––––––––––– */
function setupCongratulationsButtonEvents(){
//    $('.congratulationsModal .confirmBtn').click(function() {
      $('.congratulationsModal .confirmBtn').on('click touchstart',function(){
        $('.stage-categorySelection .goToResults').click();
    });


}

/* 10: Results
–––––––––––––––––––––––––––––––––––––––––––––––––– */
function setupResultsButtonEvents(){
    $('.stage-results .modifyBtn').click(function() {
        showStatsBar();
    });

    $('.stage-results .restartBtn').click(function() {

        reset();
        setupEventGroups();
        
    });

    $('.stage-results .downloadBtn').click(function() {
        downloadResultsTablePDF();
    });

    //$(".stage-results .restartBtn").on('click touchstart',function(){
    //    
    //  });

}

function updateResultsPage(){
    buildCategoriesTable();
    buildTotalsTable();
    buildResultsFeedback();
}

function buildCategoriesTable(){

    var table = $(".categoriesSection").find("table");
    var thead = document.createElement("thead");
    var headRow = document.createElement("tr");
    var tbody = document.createElement("tbody");

    $(table).empty();

    //Table header Stuff
    ["Item","Cost/w","Total Cost (30 yrs)"].forEach(function(el) {
        var th=document.createElement("th");
        th.appendChild(document.createTextNode(el));
        headRow.appendChild(th);
    });

    thead.appendChild(headRow);
    $(table).append(thead);
    
    for(var i=0; i< selectedCategoriesIndexes.length; i++){
        var tr = document.createElement("tr");


        [
            categoriesListArray[i].choices[selectedCategoriesIndexes[i]].name,
            currencyFormatter.format(parseFloat(categoriesListArray[i].choices[selectedCategoriesIndexes[i]].price)),
            currencyFormatter.format(parseFloat(categoriesListArray[i].choices[selectedCategoriesIndexes[i]].price*1560))
        ].forEach(function(el) {
            var td = document.createElement("td");
            td.appendChild(document.createTextNode(el));
            tr.appendChild(td);
        });

        tbody.appendChild(tr); 
        
        var feedbackTr = document.createElement("tr");
        var feedbackTd = document.createElement("td");
        feedbackTd.setAttribute("colspan", "3");
        feedbackTr.appendChild(feedbackTd);
        
         tbody.appendChild(feedbackTr); 
        

    }
    
    

    $(table).append(tbody);
}

function buildTotalsTable(){

    var table = $(".totalsSection").find("table");
    //var thead = document.createElement("thead");
    var headRow = document.createElement("tr");
    var tbody = document.createElement("tbody");

    $(table).empty();


    //Budget
    var tr = document.createElement("tr");
    [
        "Budget",
        currencyFormatter.format(budget),
        currencyFormatter.format(budget*1560)
    ].forEach(function(el) {
        var td = document.createElement("td");
        td.appendChild(document.createTextNode(el));
        tr.appendChild(td);
    });

    tbody.appendChild(tr);

    //Total spend
    tr = document.createElement("tr");
    [
        "Total cost",
        currencyFormatter.format(totalSpend),
        currencyFormatter.format(totalSpend*1560)
    ].forEach(function(el) {
        var td = document.createElement("td");
        td.appendChild(document.createTextNode(el));
        tr.appendChild(td);
    });

    tbody.appendChild(tr);

    //Remaining
    tr = document.createElement("tr");
    [
        "Remaining",
        currencyFormatter.format(budget-totalSpend),
        currencyFormatter.format((budget-totalSpend)*1560)
    ].forEach(function(el) {
        var td = document.createElement("td");
        td.appendChild(document.createTextNode(el));
        tr.appendChild(td);
    });

    tbody.appendChild(tr); 

    $(table).append(tbody);
}

function buildResultsFeedback(){
    
    var parentListDiv = ".feedbackArea ul"
    var listClass;
    var listFeedback = null;
    
    $(parentListDiv).empty();
     //For each category
    for(var i=0; i< selectedCategoriesIndexes.length; i++){
        
        if(categoriesListArray[i].choices[selectedCategoriesIndexes[i]].feedback){
            switch(categoriesListArray[i].choices[selectedCategoriesIndexes[i]].feedback.type){
                case "Good":
                    listClass = "positive";
                    break;
                  
                case "Okay":
                    listClass = "okay";
                    break;

                case "Bad":
                    listClass = "negative";
                    break;

                default:
                    listClass = "positive";
            }
            
            listFeedback = categoriesListArray[i].choices[selectedCategoriesIndexes[i]].feedback.text;
            
            $(parentListDiv).append('<li class="'+listClass+'">'+listFeedback+'</li>');
            
//            $("#categoriesResultsTable tbody").children("tr").eq(((i+1)*2)-1).children("td").append('<li class="'+listClass+'">'+listFeedback+'</li>');
            
            $("#categoriesResultsTable tbody").children("tr").eq(((i+1)*2)-1).children("td").append('<div class ="categoryFeedback"><div class="feedbackIcon '+listClass+'"></div><p>'+listFeedback+'</p></div>');

        }


    }
}

function downloadResultsTablePDF(){
    var doc = new jsPDF({
        orientation: 'portrait'
    });

    var logoImg = new Image();
    logoImg.src = "img/SIS_Primary Logo_HR.png";

    doc.addImage(logoImg,'png',7,10,60,25);

    //DATE
    var today = new Date();
    var dd = today.getDate();

    var mm = today.getMonth()+1; 
    var yyyy = today.getFullYear();
    today = dd+'/'+mm+'/'+yyyy;

    doc.setFont('helvetica');
    //    doc.setFont('HelveticaMacron');

    doc.setFontSize(12);
//    doc.setFont('GothamMedium');
//    doc.setFont('Brandon_bld');
    doc.setTextColor(79, 41, 117);
    //doc.text(today,14,43);
    doc.text(today,198,8,{align:'right'});
    
    doc.text("Name:",122,19);
    doc.rect(137,13,60,8);
    
    doc.text("Class:",122,29);
    doc.rect(137,24,60,8);
    
    doc.autoTable({
        margin: { top: 38, bottom: 10 },
        head: [["Surviving in Retirement"]],
        headStyles: {
            fillColor: 255,
            fontSize: 16,
            textColor: [79, 41, 117],
            fontStyle: 'bold',
            halign: 'center'
        }
    });
    
     doc.autoTable({
        html: '#categoriesResultsTable',

        styles: {
            fontSize: 12,
            rowPageBreak: 'auto'
        },

        headStyles: {
            fillColor: [255, 110, 50],
            fontSize: 12,
            textColor: 255,
            fontStyle: 'bold'
        },
         bodyStyles:{
             cellPadding: { top: 2, right: 2, bottom: 6, left: 2 },
         },
         alternateRowStyles:{
             cellPadding: { top: 2, right: 2, bottom: 2, left: 2},
            fontStyle: 'bold'
         },
        didParseCell: (data) => {
            if (data.column.index === 0) {
                data.cell.styles.cellWidth = 103;
                data.cell.styles.halign = 'left';
            }
            else if (data.column.index === 1) {
                data.cell.styles.cellWidth = 40;
                data.cell.styles.halign = 'right';
            }
            else if (data.column.index === 2) {
                data.cell.styles.cellWidth = 40;
                data.cell.styles.halign = 'right';
            }
        }
    });

    doc.autoTable({
        html: '#totalsResultsTable',

        styles: {
            fontSize: 12,
            rowPageBreak: 'auto'
        },
 
        headStyles: {
            fillColor: [255, 110, 50],
            fontSize: 12,
            textColor: 255,
            fontStyle: 'bold'
        },
        didParseCell: (data) => {
            if (data.column.index === 0) {
                data.cell.styles.cellWidth = 103;
                data.cell.styles.halign = 'left';
            }
            else if (data.column.index === 1) {
                data.cell.styles.cellWidth = 40;
                data.cell.styles.halign = 'right';
            }
            else if (data.column.index === 2) {
                data.cell.styles.cellWidth = 40;
                data.cell.styles.halign = 'right';
            }
            
            if (data.row.index === 0) {
                data.cell.styles.fillColor =  255;
                data.cell.styles.textColor = [79, 41, 117];
            }
            
            else if (data.row.index === 1) {
                data.cell.styles.fillColor =  255;
                data.cell.styles.textColor = [79, 41, 117];
            }
            
            else if (data.row.index === 2) {
                data.cell.styles.fillColor =  [79, 41, 117];
                data.cell.styles.textColor = 255;
            }
        }
    });
    
    doc.save('Surviving in Retirement.pdf');
}
